Index: kernel/arch/ppc32/Makefile.inc
===================================================================
--- kernel/arch/ppc32/Makefile.inc	(revision 3a7db87a903458657c7b6e44aaf827cf133aded2)
+++ kernel/arch/ppc32/Makefile.inc	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -59,2 +59,6 @@
 	arch/$(KARCH)/src/mm/tlb.c \
 	arch/$(KARCH)/src/drivers/pic.c
+
+ARCH_AUTOGENS_AG = \
+	arch/$(KARCH)/include/arch/istate_struct.ag
+
Index: kernel/arch/ppc32/include/arch/istate.h
===================================================================
--- kernel/arch/ppc32/include/arch/istate.h	(revision 3a7db87a903458657c7b6e44aaf827cf133aded2)
+++ kernel/arch/ppc32/include/arch/istate.h	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -40,55 +40,13 @@
 #ifdef KERNEL
 
-#include <typedefs.h>
+#include <arch/istate_struct.h>
 #include <arch/msr.h>
 
 #else /* KERNEL */
 
-#include <sys/types.h>
+#include <libarch/istate_struct.h>
 #include <libarch/msr.h>
 
 #endif /* KERNEL */
-
-typedef struct istate {
-	uint32_t r0;
-	uint32_t r2;
-	uint32_t r3;
-	uint32_t r4;
-	uint32_t r5;
-	uint32_t r6;
-	uint32_t r7;
-	uint32_t r8;
-	uint32_t r9;
-	uint32_t r10;
-	uint32_t r11;
-	uint32_t r13;
-	uint32_t r14;
-	uint32_t r15;
-	uint32_t r16;
-	uint32_t r17;
-	uint32_t r18;
-	uint32_t r19;
-	uint32_t r20;
-	uint32_t r21;
-	uint32_t r22;
-	uint32_t r23;
-	uint32_t r24;
-	uint32_t r25;
-	uint32_t r26;
-	uint32_t r27;
-	uint32_t r28;
-	uint32_t r29;
-	uint32_t r30;
-	uint32_t r31;
-	uint32_t cr;
-	uint32_t pc;
-	uint32_t srr1;
-	uint32_t lr;
-	uint32_t ctr;
-	uint32_t xer;
-	uint32_t dar;
-	uint32_t r12;
-	uint32_t sp;
-} istate_t;
 
 NO_TRACE static inline void istate_set_retaddr(istate_t *istate,
Index: kernel/arch/ppc32/include/arch/istate_struct.ag
===================================================================
--- kernel/arch/ppc32/include/arch/istate_struct.ag	(revision beb16cfab60e9cad4457c189c54a916ace701046)
+++ kernel/arch/ppc32/include/arch/istate_struct.ag	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -0,0 +1,212 @@
+# Copyright (c) 2014 Jakub Jermar 
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+{
+        name : istate,
+
+        includes : [
+                {
+                        guard : KERNEL,
+                        include : <typedefs.h>
+                },
+                {
+                        negative-guard : KERNEL,
+                        include : <sys/types.h>
+                }
+        ],
+
+        members : [
+                {
+                        # imitation of frame pointer linkage
+                        name : sp_frame,
+                        type : uint32_t
+                },
+                {
+                        # imitation of return adress linkage
+                        name : lr_frame,
+                        type : uint32_t
+                },
+                {
+                        name : r0,
+                        type : uint32_t
+                },
+                {
+                        name : r2,
+                        type : uint32_t
+                },
+                {
+                        name : r3,
+                        type : uint32_t
+                },
+                {
+                        name : r4,
+                        type : uint32_t
+                },
+                {
+                        name : r5,
+                        type : uint32_t
+                },
+                {
+                        name : r6,
+                        type : uint32_t
+                },
+                {
+                        name : r7,
+                        type : uint32_t
+                },
+                {
+                        name : r8,
+                        type : uint32_t
+                },
+                {
+                        name : r9,
+                        type : uint32_t
+                },
+                {
+                        name : r10,
+                        type : uint32_t
+                },
+                {
+                        name : r11,
+                        type : uint32_t
+                },
+                {
+                        name : r13,
+                        type : uint32_t
+                },
+                {
+                        name : r14,
+                        type : uint32_t
+                },
+                {
+                        name : r15,
+                        type : uint32_t
+                },
+                {
+                        name : r16,
+                        type : uint32_t
+                },
+                {
+                        name : r17,
+                        type : uint32_t
+                },
+                {
+                        name : r18,
+                        type : uint32_t
+                },
+                {
+                        name : r19,
+                        type : uint32_t
+                },
+                {
+                        name : r20,
+                        type : uint32_t
+                },
+                {
+                        name : r21,
+                        type : uint32_t
+                },
+                {
+                        name : r22,
+                        type : uint32_t
+                },
+                {
+                        name : r23,
+                        type : uint32_t
+                },
+                {
+                        name : r24,
+                        type : uint32_t
+                },
+                {
+                        name : r25,
+                        type : uint32_t
+                },
+                {
+                        name : r26,
+                        type : uint32_t
+                },
+                {
+                        name : r27,
+                        type : uint32_t
+                },
+                {
+                        name : r28,
+                        type : uint32_t
+                },
+                {
+                        name : r29,
+                        type : uint32_t
+                },
+                {
+                        name : r30,
+                        type : uint32_t
+                },
+                {
+                        name : r31,
+                        type : uint32_t
+                },
+                {
+                        name : cr,
+                        type : uint32_t
+                },
+                {
+                        name : pc,
+                        type : uint32_t
+                },
+                {
+                        name : srr1,
+                        type : uint32_t
+                },
+                {
+                        name : lr,
+                        type : uint32_t
+                },
+                {
+                        name : ctr,
+                        type : uint32_t
+                },
+                {
+                        name : xer,
+                        type : uint32_t
+                },
+                {
+                        name : dar,
+                        type : uint32_t
+                },
+                {
+                        name : r12,
+                        type : uint32_t
+                },
+                {
+                        name : sp,
+                        type : uint32_t
+                }
+
+        ]
+}
+
Index: kernel/arch/ppc32/include/arch/stack.h
===================================================================
--- kernel/arch/ppc32/include/arch/stack.h	(revision 3a7db87a903458657c7b6e44aaf827cf133aded2)
+++ kernel/arch/ppc32/include/arch/stack.h	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -40,4 +40,6 @@
 #define MEM_STACK_SIZE	STACK_SIZE
 
+#define STACK_ALIGNMENT	16
+
 #endif
 
Index: kernel/arch/ppc32/src/asm.S
===================================================================
--- kernel/arch/ppc32/src/asm.S	(revision 3a7db87a903458657c7b6e44aaf827cf133aded2)
+++ kernel/arch/ppc32/src/asm.S	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -29,4 +29,5 @@
 #include <arch/asm/regname.h>
 #include <arch/msr.h>
+#include <arch/istate_struct.h>
 
 .text
@@ -85,55 +86,55 @@
 	mtmsr r31
 	
-	lwz r0, 8(sp)
-	lwz r2, 12(sp)
-	lwz r3, 16(sp)
-	lwz r4, 20(sp)
-	lwz r5, 24(sp)
-	lwz r6, 28(sp)
-	lwz r7, 32(sp)
-	lwz r8, 36(sp)
-	lwz r9, 40(sp)
-	lwz r10, 44(sp)
-	lwz r11, 48(sp)
-	lwz r13, 52(sp)
-	lwz r14, 56(sp)
-	lwz r15, 60(sp)
-	lwz r16, 64(sp)
-	lwz r17, 68(sp)
-	lwz r18, 72(sp)
-	lwz r19, 76(sp)
-	lwz r20, 80(sp)
-	lwz r21, 84(sp)
-	lwz r22, 88(sp)
-	lwz r23, 92(sp)
-	lwz r24, 96(sp)
-	lwz r25, 100(sp)
-	lwz r26, 104(sp)
-	lwz r27, 108(sp)
-	lwz r28, 112(sp)
-	lwz r29, 116(sp)
-	lwz r30, 120(sp)
-	lwz r31, 124(sp)
-	
-	lwz r12, 128(sp)
+	lwz r0, ISTATE_OFFSET_R0(sp)
+	lwz r2, ISTATE_OFFSET_R2(sp)
+	lwz r3, ISTATE_OFFSET_R3(sp)
+	lwz r4, ISTATE_OFFSET_R4(sp)
+	lwz r5, ISTATE_OFFSET_R5(sp)
+	lwz r6, ISTATE_OFFSET_R6(sp)
+	lwz r7, ISTATE_OFFSET_R7(sp)
+	lwz r8, ISTATE_OFFSET_R8(sp)
+	lwz r9, ISTATE_OFFSET_R9(sp)
+	lwz r10, ISTATE_OFFSET_R10(sp)
+	lwz r11, ISTATE_OFFSET_R11(sp)
+	lwz r13, ISTATE_OFFSET_R13(sp)
+	lwz r14, ISTATE_OFFSET_R14(sp)
+	lwz r15, ISTATE_OFFSET_R15(sp)
+	lwz r16, ISTATE_OFFSET_R16(sp)
+	lwz r17, ISTATE_OFFSET_R17(sp)
+	lwz r18, ISTATE_OFFSET_R18(sp)
+	lwz r19, ISTATE_OFFSET_R19(sp)
+	lwz r20, ISTATE_OFFSET_R20(sp)
+	lwz r21, ISTATE_OFFSET_R21(sp)
+	lwz r22, ISTATE_OFFSET_R22(sp)
+	lwz r23, ISTATE_OFFSET_R23(sp)
+	lwz r24, ISTATE_OFFSET_R24(sp)
+	lwz r25, ISTATE_OFFSET_R25(sp)
+	lwz r26, ISTATE_OFFSET_R26(sp)
+	lwz r27, ISTATE_OFFSET_R27(sp)
+	lwz r28, ISTATE_OFFSET_R28(sp)
+	lwz r29, ISTATE_OFFSET_R29(sp)
+	lwz r30, ISTATE_OFFSET_R30(sp)
+	lwz r31, ISTATE_OFFSET_R31(sp)
+	
+	lwz r12, ISTATE_OFFSET_CR(sp)
 	mtcr r12
 	
-	lwz r12, 132(sp)
+	lwz r12, ISTATE_OFFSET_PC(sp)
 	mtsrr0 r12
 	
-	lwz r12, 136(sp)
+	lwz r12, ISTATE_OFFSET_SRR1(sp)
 	mtsrr1 r12
 	
-	lwz r12, 140(sp)
+	lwz r12, ISTATE_OFFSET_LR(sp)
 	mtlr r12
 	
-	lwz r12, 144(sp)
+	lwz r12, ISTATE_OFFSET_CTR(sp)
 	mtctr r12
 	
-	lwz r12, 148(sp)
+	lwz r12, ISTATE_OFFSET_XER(sp)
 	mtxer r12
 	
-	lwz r12, 156(sp)
-	lwz sp, 160(sp)
+	lwz r12, ISTATE_OFFSET_R12(sp)
+	lwz sp, ISTATE_OFFSET_SP(sp)
 	
 	rfi
@@ -152,54 +153,54 @@
 	mtmsr r31
 	
-	lwz r0, 8(sp)
-	lwz r2, 12(sp)
-	lwz r4, 20(sp)
-	lwz r5, 24(sp)
-	lwz r6, 28(sp)
-	lwz r7, 32(sp)
-	lwz r8, 36(sp)
-	lwz r9, 40(sp)
-	lwz r10, 44(sp)
-	lwz r11, 48(sp)
-	lwz r13, 52(sp)
-	lwz r14, 56(sp)
-	lwz r15, 60(sp)
-	lwz r16, 64(sp)
-	lwz r17, 68(sp)
-	lwz r18, 72(sp)
-	lwz r19, 76(sp)
-	lwz r20, 80(sp)
-	lwz r21, 84(sp)
-	lwz r22, 88(sp)
-	lwz r23, 92(sp)
-	lwz r24, 96(sp)
-	lwz r25, 100(sp)
-	lwz r26, 104(sp)
-	lwz r27, 108(sp)
-	lwz r28, 112(sp)
-	lwz r29, 116(sp)
-	lwz r30, 120(sp)
-	lwz r31, 124(sp)
-	
-	lwz r12, 128(sp)
+	lwz r0, ISTATE_OFFSET_R0(sp)
+	lwz r2, ISTATE_OFFSET_R2(sp)
+	lwz r4, ISTATE_OFFSET_R4(sp)
+	lwz r5, ISTATE_OFFSET_R5(sp)
+	lwz r6, ISTATE_OFFSET_R6(sp)
+	lwz r7, ISTATE_OFFSET_R7(sp)
+	lwz r8, ISTATE_OFFSET_R8(sp)
+	lwz r9, ISTATE_OFFSET_R9(sp)
+	lwz r10, ISTATE_OFFSET_R10(sp)
+	lwz r11, ISTATE_OFFSET_R11(sp)
+	lwz r13, ISTATE_OFFSET_R13(sp)
+	lwz r14, ISTATE_OFFSET_R14(sp)
+	lwz r15, ISTATE_OFFSET_R15(sp)
+	lwz r16, ISTATE_OFFSET_R16(sp)
+	lwz r17, ISTATE_OFFSET_R17(sp)
+	lwz r18, ISTATE_OFFSET_R18(sp)
+	lwz r19, ISTATE_OFFSET_R19(sp)
+	lwz r20, ISTATE_OFFSET_R20(sp)
+	lwz r21, ISTATE_OFFSET_R21(sp)
+	lwz r22, ISTATE_OFFSET_R22(sp)
+	lwz r23, ISTATE_OFFSET_R23(sp)
+	lwz r24, ISTATE_OFFSET_R24(sp)
+	lwz r25, ISTATE_OFFSET_R25(sp)
+	lwz r26, ISTATE_OFFSET_R26(sp)
+	lwz r27, ISTATE_OFFSET_R27(sp)
+	lwz r28, ISTATE_OFFSET_R28(sp)
+	lwz r29, ISTATE_OFFSET_R29(sp)
+	lwz r30, ISTATE_OFFSET_R30(sp)
+	lwz r31, ISTATE_OFFSET_R31(sp)
+	
+	lwz r12, ISTATE_OFFSET_CR(sp)
 	mtcr r12
 	
-	lwz r12, 132(sp)
+	lwz r12, ISTATE_OFFSET_PC(sp)
 	mtsrr0 r12
 	
-	lwz r12, 136(sp)
+	lwz r12, ISTATE_OFFSET_SRR1(sp)
 	mtsrr1 r12
 	
-	lwz r12, 140(sp)
+	lwz r12, ISTATE_OFFSET_LR(sp)
 	mtlr r12
 	
-	lwz r12, 144(sp)
+	lwz r12, ISTATE_OFFSET_CTR(sp)
 	mtctr r12
 	
-	lwz r12, 148(sp)
+	lwz r12, ISTATE_OFFSET_XER(sp)
 	mtxer r12
 	
-	lwz r12, 156(sp)
-	lwz sp, 160(sp)
+	lwz r12, ISTATE_OFFSET_R12(sp)
+	lwz sp, ISTATE_OFFSET_SP(sp)
 	
 	rfi
Index: kernel/arch/ppc32/src/exception.S
===================================================================
--- kernel/arch/ppc32/src/exception.S	(revision 3a7db87a903458657c7b6e44aaf827cf133aded2)
+++ kernel/arch/ppc32/src/exception.S	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -30,4 +30,7 @@
 #include <arch/msr.h>
 #include <arch/mm/page.h>
+#include <arch/istate_struct.h>
+#include <align.h>
+#include <arch/stack.h>
 
 .section K_UNMAPPED_TEXT_START, "ax"
@@ -62,64 +65,65 @@
 	2:
 	
-	subi sp, sp, 176
-	stw r0, 8(sp)
-	stw r2, 12(sp)
-	stw r3, 16(sp)
-	stw r4, 20(sp)
-	stw r5, 24(sp)
-	stw r6, 28(sp)
-	stw r7, 32(sp)
-	stw r8, 36(sp)
-	stw r9, 40(sp)
-	stw r10, 44(sp)
-	stw r11, 48(sp)
-	stw r13, 52(sp)
-	stw r14, 56(sp)
-	stw r15, 60(sp)
-	stw r16, 64(sp)
-	stw r17, 68(sp)
-	stw r18, 72(sp)
-	stw r19, 76(sp)
-	stw r20, 80(sp)
-	stw r21, 84(sp)
-	stw r22, 88(sp)
-	stw r23, 92(sp)
-	stw r24, 96(sp)
-	stw r25, 100(sp)
-	stw r26, 104(sp)
-	stw r27, 108(sp)
-	stw r28, 112(sp)
-	stw r29, 116(sp)
-	stw r30, 120(sp)
-	stw r31, 124(sp)
-	
-	stw r12, 128(sp)
+	subi sp, sp, ALIGN_UP(ISTATE_SIZE, STACK_ALIGNMENT)
+	stw r0, ISTATE_OFFSET_R0(sp)
+	stw r2, ISTATE_OFFSET_R2(sp)
+	stw r3, ISTATE_OFFSET_R3(sp)
+	stw r4, ISTATE_OFFSET_R4(sp)
+	stw r5, ISTATE_OFFSET_R5(sp)
+	stw r6, ISTATE_OFFSET_R6(sp)
+	stw r7, ISTATE_OFFSET_R7(sp)
+	stw r8, ISTATE_OFFSET_R8(sp)
+	stw r9, ISTATE_OFFSET_R9(sp)
+	stw r10, ISTATE_OFFSET_R10(sp)
+	stw r11, ISTATE_OFFSET_R11(sp)
+	stw r13, ISTATE_OFFSET_R13(sp)
+	stw r14, ISTATE_OFFSET_R14(sp)
+	stw r15, ISTATE_OFFSET_R15(sp)
+	stw r16, ISTATE_OFFSET_R16(sp)
+	stw r17, ISTATE_OFFSET_R17(sp)
+	stw r18, ISTATE_OFFSET_R18(sp)
+	stw r19, ISTATE_OFFSET_R19(sp)
+	stw r20, ISTATE_OFFSET_R20(sp)
+	stw r21, ISTATE_OFFSET_R21(sp)
+	stw r22, ISTATE_OFFSET_R22(sp)
+	stw r23, ISTATE_OFFSET_R23(sp)
+	stw r24, ISTATE_OFFSET_R24(sp)
+	stw r25, ISTATE_OFFSET_R25(sp)
+	stw r26, ISTATE_OFFSET_R26(sp)
+	stw r27, ISTATE_OFFSET_R27(sp)
+	stw r28, ISTATE_OFFSET_R28(sp)
+	stw r29, ISTATE_OFFSET_R29(sp)
+	stw r30, ISTATE_OFFSET_R30(sp)
+	stw r31, ISTATE_OFFSET_R31(sp)
+	
+	stw r12, ISTATE_OFFSET_CR(sp)
 	
 	mfsrr0 r12
-	stw r12, 132(sp)
+	stw r12, ISTATE_OFFSET_PC(sp)
 	
 	mfsrr1 r12
-	stw r12, 136(sp)
+	stw r12, ISTATE_OFFSET_SRR1(sp)
 	
 	mflr r12
-	stw r12, 140(sp)
+	stw r12, ISTATE_OFFSET_LR(sp)
 	
 	mfctr r12
-	stw r12, 144(sp)
+	stw r12, ISTATE_OFFSET_CTR(sp)
 	
 	mfxer r12
-	stw r12, 148(sp)
+	stw r12, ISTATE_OFFSET_XER(sp)
 	
 	mfdar r12
-	stw r12, 152(sp)
+	stw r12, ISTATE_OFFSET_DAR(sp)
 	
 	mfsprg1 r12
-	stw r12, 156(sp)
+	stw r12, ISTATE_OFFSET_R12(sp)
 	
 	mfsprg2 r12
-	stw r12, 160(sp)
+	stw r12, ISTATE_OFFSET_SP(sp)
 
 	li r12, 0
-	stw r12, 0(sp)
+	stw r12, ISTATE_OFFSET_LR_FRAME(sp)
+	stw r12, ISTATE_OFFSET_SP_FRAME(sp)
 .endm
 
@@ -270,5 +274,4 @@
 	addis sp, sp, 0x8000
 	mr r4, sp
-	addi r4, r4, 8
 	
 	rfi
Index: uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h	(revision beb16cfab60e9cad4457c189c54a916ace701046)
+++ uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h	(revision beb16cfab60e9cad4457c189c54a916ace701046)
@@ -0,0 +1,1 @@
+../../../../../../../kernel/arch/ppc32/include/arch/istate_struct.h
